#ifndef DISTANCE_H
#define DISTANCE_H

#if defined(__cplusplus)
extern "C" {
#endif

#include "cb.h"

typedef enum { DT_User, DT_Euclidean, DT_EuclideanSquare,
    DT_Manhattan, DT_DeltaSC, DT_CodeLength, DT_DeltaMSE } DT_TYPE;

/* defines for direction */
#define DT_FROM_MODEL 2
#define DT_TO_MODEL 1
#define DT_DATA2DATA 0
#define DT_MODEL2DATA DT_FROM_MODEL
#define DT_DATA2MODEL DT_TO_MODEL
#define DT_MODEL2MODEL (DT_FROM_MODEL | DT_TO_MODEL)

/* Parameters are same as for diDistance, except for DI. */
typedef float (*DT_DistanceFunction)(
    TRAININGSET*, CODEBOOK*, PARTITIONING*, int, int, int);

typedef struct {
    DT_TYPE Type;
    DT_DistanceFunction F[4];
} DistanceInfo;

DistanceInfo* diNew(TRAININGSET* TS, DT_TYPE Type,
    DT_DistanceFunction Data2Data, DT_DistanceFunction Data2Model,
    DT_DistanceFunction Model2Data, DT_DistanceFunction Model2Model);
void diDelete(DistanceInfo* DI);
/*
float diDistance(DistanceInfo* DI,
    TRAININGSET* TS, CODEBOOK* CB, PARTITIONING* PA,
    int From, int To, int Direction);
*/

#define diDistance(DI, TS, CB, PA, From, To, Direction) \
    ((DI)->F[Direction])((TS), (CB), (PA), (From), (To), (Direction))

#if defined(__cplusplus)
}
#endif

#endif
