#ifndef MDL_H
#define MDL_H

#if defined(__cplusplus)
extern "C" {
#endif

#include "cb.h"
#include "DistCrit/distance.h"


void* InitMDL(DistanceInfo* DI, TRAININGSET* TS);
void DoneMDL(void* AuxiliaryData);
float CalculateMDL(DistanceInfo* DI, TRAININGSET* TS,
    CODEBOOK* CB, PARTITIONING* PA, void* AuxiliaryData);
float MDLDelta(TRAININGSET* TS,
    CODEBOOK* CB, PARTITIONING* PA, int From, int To, int Direction);
int MDLCentroid(DistanceInfo* DI, TRAININGSET* TS,
    CODEBOOK* CB, PARTITIONING* PA, int* Changed, void* AuxiliaryData);
int MDLPartition(DistanceInfo* DI, TRAININGSET* TS,
    CODEBOOK* CB, PARTITIONING* PA, int* Changed, void* AuxiliaryData);
int MDLLocal(DistanceInfo* DI, TRAININGSET* TS,
    CODEBOOK* CB, PARTITIONING* PA, int* Changes, int Changed,
    void* AuxiliaryData);

#if defined(__cplusplus)
}
#endif

#endif
