#ifndef STCOMPLX_H
#define STCOMPLX_H

#if defined(__cplusplus)
extern "C" {
#endif

#include "cb.h"
#include "DistCrit/distance.h"

void* InitStochasticComplexity(DistanceInfo* DI, TRAININGSET* TS);
void DoneStochasticComplexity(void* AuxiliaryData);
float CalculateStochasticComplexity(DistanceInfo* DI, TRAININGSET* TS,
    CODEBOOK* CB, PARTITIONING* PA, void* AuxiliaryData);
int StochasticComplexityPartition(DistanceInfo* DI, TRAININGSET* TS,
    CODEBOOK* CB, PARTITIONING* PA, int* Changed, void* UnusedParameter);
int StochasticComplexityLocal(DistanceInfo* DI, TRAININGSET* TS,
    CODEBOOK* CB, PARTITIONING* PA, int* Changes, int Changed,
    void* UnusedParameter);
int StochasticComplexityCentroid(DistanceInfo* DI, TRAININGSET* TS,
    CODEBOOK* CB, PARTITIONING* PA, int* Changed, void* UnusedParameter);
float StochasticComplexityDelta(TRAININGSET* TS,
    CODEBOOK* CB, PARTITIONING* PA, int From, int To, int Direction);

#if defined(__cplusplus)
}
#endif

#endif
