#ifndef ITER_H
#define ITER_H

#if defined(__cplusplus)
extern "C" {
#endif

typedef enum { I_User, I_Fixed, I_NTimes, I_FiftyFiftyRatio,
    I_EstimatedImprovement, I_Last } I_TYPE;

typedef int (*I_StoppingFunction)(float, int, float*);

typedef struct {
    I_TYPE Type;
    float* Values;
    int ValuesAllocated;
    int Count;
    int MinimumIterations;
    int MaximumIterations;
    float Limit;
    I_StoppingFunction Func;
} Iterations;

Iterations* itNew(I_TYPE T, int MinIterations, float Limit, int MaxIterations,
    I_StoppingFunction F);
void itReset(Iterations* I);
void itDelete(Iterations* I);
int itStop(Iterations* I, float Value);

#define itCount(Iter) ((Iter)->Count)

#if defined(__cplusplus)
}
#endif

#endif
