#ifndef LOGGER_H
#define LOGGER_H

#if defined(__cplusplus)
extern "C" {
#endif

#ifdef USE_LOGGER

#include <stdio.h>

extern FILE* logFile;

#define logOn() (logFile != NULL)
#define logStream(File) (logFile = (File))
#define logAdd(ID) fprintf(logFile, "%s\n", (ID))
#define logAddValue(Value) fprintf(logFile, "\t%.6g\n", (Value))
#define logAdd1(ID, Value) \
    fprintf(logFile, "%s\t%.6g\n", (ID), (Value))
#define logAdd2(ID, Value1, Value2) \
    fprintf(logFile, "%s\t%.6g\t%.6g\n", (ID), (Value1), (Value2))
#define logAdd3(ID, Value1, Value2, Value3) \
    fprintf(logFile, "%s\t%.6g\t%.6g\t%.6g\n", (ID), (Value1), (Value2), (Value3))

const char* logID();
float logValue(int* FailureCode);

#else

#define logOn() 0
#define logStream(File)
#define logAdd(ID)
#define logAddValue(Value)
#define logAdd1(ID, Value)
#define logAdd2(ID, Value1, Value2)
#define logAdd3(ID, Value1, Value2, Value3)

#define logID()
#define logValue(FailureCode)

#endif

#if defined(__cplusplus)
}
#endif

#endif

