/*
 * gcc -I. -ggdb test_matrix.cpp -o test_matrix -lm
 */

#include "matrix.hpp"
#include "matrix.cpp"

#include <stdio.h>


int main() {
    Matrix* mem = (Matrix*)malloc(sizeof(Matrix));
    NewMatrixAllocated(mem, 4, 4);
    Matrix& M = *mem;
    for (int r = 0; r < M.Rows(); ++r) for (int c = 0; c < M.Cols(); ++c)
        M(r, c) = r * c;
    M.Print(stdout);
    fprintf(stdout, "\n");
    Matrix A(M);
    A *= -1.0f;
    M += A;
    M.Print(stdout);
    fprintf(stdout, "\n");
    M -= A;
    M.Print(stdout);
    fprintf(stdout, "\n");
    M *= A;
    M.Print(stdout);
    fprintf(stdout, "\n");
    M(0, 0) = 1; M(0, 1) = 2; M(0, 2) = 3; M(0, 3) = 4;
    M(1, 0) = 2; M(1, 1) = 2; M(1, 2) = 0; M(1, 3) = 0;
    M(2, 0) = 3; M(2, 1) = 0; M(2, 2) = -1; M(2, 3) = -1;
    M(3, 0) = 4; M(3, 1) = 0; M(3, 2) = -1; M(3, 3) = 1;
    M.Print(stdout);
    fprintf(stdout, "\n");
    A = M.Inverse();
    A.Print(stdout);
    fprintf(stdout, "\n");
    M *= A;
    M.Print(stdout);
    fprintf(stdout, "\n");
    printf("%f\n", A.Determinant());
    printf("%f\n", M.Determinant());
    DeleteMatrixAllocated(mem);
    free(mem);
    return 0;
}

