#include "timer.h"
#include <sys/time.h>

static struct timeval LastSnapshot;
long timerSeconds, timerMicroseconds;

void timerSnapshot() {
    struct timeval Now;
    gettimeofday(&Now, 0);
    timerSeconds = Now.tv_sec - LastSnapshot.tv_sec;
    timerMicroseconds = Now.tv_usec - LastSnapshot.tv_usec;
    if (timerMicroseconds < 0) { /* Period spans second boundary. */
        --timerSeconds;
        timerMicroseconds += 1000000;
    }
    if (timerSeconds < 0) timerSeconds += 86400; /* Period spans midnight. */
    LastSnapshot.tv_sec = Now.tv_sec;
    LastSnapshot.tv_usec = Now.tv_usec;
}

