#ifndef TRACEDB_H
#define TRACEDB_H

#if defined(__cplusplus)
extern "C" {
#endif

#include "fvec.h"

#define TDB_DIMENSIONALITY 4

typedef struct {
    int Begin[TDB_DIMENSIONALITY + 1];
    int End[TDB_DIMENSIONALITY + 1];
} TDBRanges;

TDBRanges* tdbrNew(int VectorCount);
void tdbrInitialize(TDBRanges* R, int VectorCount);
void tdbrDelete(TDBRanges* R);
#define tdbrBegin(R, k) ((R)->Begin[k])
#define tdbrEnd(R, k) ((R)->End[k])

int tdbRead(float*** Set, int* Count, FILE* f);
int tdbSeek(float** Set, TDBRanges* R, int Dimension, float Value);
int tdbFind(float** Set, TDBRanges* R,
    float Val0, float Val1, float Val2, float Val3);
float** tdbValueMAMM(float** Set, int Count, int* MAMMCount);
float** tdbIterationMAMM(float** Set, int Count, int* MAMMCount);
float** tdbCombine(float** Set, int Count, int Times, int* CombinedCount);

enum { TDB_MAMM_MIN = 0, TDB_MAMM_AVG, TDB_MAMM_MED, TDB_MAMM_MAX,
    TDB_MAMM_LAST };


#if defined(__cplusplus)
}
#endif

#endif
