#if !defined(VPTREE_H)
#define VPTREE_H

#if defined(__cplusplus)
extern "C" {
#endif

#include "cb.h"
#include "DistCrit/distance.h"

typedef struct {
    int Point;
    float Dist;
} VPTreeNode;

typedef struct {
    int Count;
    VPTreeNode* Tree;
    TRAININGSET* TS;
    DistanceInfo* DI;
    int BufferSize;
    VPTreeNode* Buffer;
    int PointsTouched;
    int SearchCount;
} VPTree;

VPTree* vptNew(TRAININGSET* TS, DistanceInfo* DI);
void vptDelete(VPTree* V);
void vptNeighbors(VPTree* V, int Point,
    int Count, int* Indices, float* Distances);

#if defined(__cplusplus)
}
#endif

#endif

